#/bin/bash 

set -e
set -x

main()
{

   # update submodules
    git submodule sync --recursive
    git submodule update --recursive --init

	# gather info for debugging later, probably not necessary 
	pwd
	hostname
	whoami
	env|grep "^CICD"

	local orig_dir=$(pwd)

	# puts peasoup_umbrella (and all submodules) in CICD_MODULE_WORK_DIR
	cicd_setup_module_dependency allnp/peasoup_umbrella.git stars_umbrella


	# puts the version of zipr to test in stars_umbrella/SMPStaticAnalyzer.
	cicd_put_module_in_tree stars_umbrella/SMPStaticAnalyzer

	# Build peasoup_umbrella as stars_umbrella
	cd $CICD_MODULE_WORK_DIR/stars_umbrella
	source set_env_vars
	sudo ./get-peasoup-packages.sh all
	./build-all.sh
	dropdb $PGDATABASE 2>/dev/null || true ; ./postgres_setup.sh

	cd $orig_dir
}

main "$@"
