#ifndef STARS_IRDB_Function_h
#define STARS_IRDB_Function_h

#include "interfaces/STARSTypes.h"
#include <irdb-core>
//#include <bea_deprecated.hpp>

class SMPFunction;
class SMPInstr;

class STARS_IRDB_Function_t : public STARS_Function_t 
{
public:

	STARS_IRDB_Function_t(IRDB_SDK::Function_t* f, IRDB_SDK::FileIR_t* _firp) : the_func(f), firp(_firp)
	{ 
	}

	// obvious
	virtual char* GetFunctionName(char* name, const int len) const 
	{ strncpy((char*)name,the_func->getName().c_str(),len); return (char*)name; }

	// get entry point of function
	virtual STARS_ea_t get_startEA() { return the_func->getEntryPoint()->getBaseID(); }

	// clc needs to review and get back to me.
	virtual STARS_ea_t get_endEA() { assert(0); }

	virtual STARS_ea_t getFuncID(void) const { return (STARS_ea_t) the_func->getBaseID(); };

	// return # of instructions.
	virtual std::size_t GetFuncSize() { return the_func->getInstructions().size(); } 


#if 1
//This chunk of things is going away?
	// init class-local variable with IRDB value
	// and these are accessors to that.
	virtual std::size_t GetFrameSize(){ return the_func->getStackFrameSize(); }


	// should go away.
	virtual void SetFrameSize(std::size_t size) { assert(0); }

	// todo for clc: audit these functions and see if they are really getting info from idapro
	// or if these can be removed from the interface because they are calculated by STARS 
	// interface-independent routines.
	// eventually going away.


	virtual std::size_t GetSavedRegSize() 
	{ 

// tmp for debugging
return 0;
		std::size_t size=0;
		IRDB_SDK::Instruction_t* insn=the_func->getEntryPoint();
		while(insn && insn->getTarget()==NULL)
		{
			auto d=IRDB_SDK::DecodedInstruction_t::factory(insn);
			if(d->getMnemonic()=="push" )
				size+=(firp->getArchitectureBitWidth()/8);
			insn=insn->getFallthrough();
		}

		return size;
	}
	virtual std::size_t GetIncomingArgumentSize() 
	{ 
// tmp for debugging
return 0;
		assert(0); 
	}
	virtual std::size_t GetFrameReturnAddressSize() 
	{ 
		std::size_t size=(std::size_t)firp->getArchitectureBitWidth();
		size/=8;
		return size;
//		assert(0); 
	}
 

	virtual bool FunctionUsesFP(){ return the_func->getUseFramePointer(); }
	virtual bool IsStaticFunction(){ return false; }
	virtual bool IsLibraryFunction(){ return false; }
	virtual bool IsStackPointerAnalyzed(){ return false; }
	virtual STARS_sval_t get_spd(STARS_ea_t ea){ return 0; }
	virtual bool HasReturnPoints(){ return true; }
	virtual bool IsMultiEntry(bool HasIndirectJumps){ return false; }
	virtual void MarkSharedChunks(){ return; }
	virtual bool HasSharedChunks() const { return false; }
	virtual void SetSharedChunks(bool v) { return; }
	virtual void UpdateXrefs(){ return; }
	virtual void FillInLocalVarTable(SMPFunction *CurrFunc) { return; }
	virtual void FindEHCatchBlocks(void) { return; }
	virtual bool IsChunkUnshared(STARS_ea_t ChunkAddr, STARS_ea_t FuncHeadStart, STARS_ea_t FuncHeadEnd) { return true; }
#endif

	virtual void BuildFuncIR(SMPFunction *func);

	virtual void FindFixedCalls(SMPFunction *CurrFunc);

	virtual bool FindDistantCodeFragment(SMPFunction* func, STARS_ea_t TargetAddr)
	{ return false; } 


	// see src/ file.
	virtual bool AnalyzeInstAsCallTarget(SMPFunction *CurrFunc, 
	                                     bool &IsIndirectCallTarget, 
	                                     bool &IsTailCallTarget) ;

	// see src/ dir.
	virtual bool IsInstIDInFunc(STARS_ea_t InstID);


private:
	IRDB_SDK::Function_t* the_func;
	IRDB_SDK::FileIR_t* firp;

	// disallow access to class members.
	static void IRDB_IR_Build_helper
				(
						SMPFunction *func,
						SMPInstr *CurrInst
				);


};

#endif
