#ifndef STARS_SSA_Instruction_h
#define STARS_SSA_Instruction_h

#include <memory>
#include <cstddef>
#include <cstdint>

#include <assert.h>
#include <map>

#include "interfaces/STARSTypes.h"
#include "interfaces/SMPDBInterface.h"
#include "interfaces/abstract/STARSInstructionID.h"
#include "interfaces/abstract/STARSInstruction.h"

class SMPInstr;

class STARS_SSA_Instruction_t : public STARS_Instruction_t
{
	public:

		// Constructors and destructors
		STARS_SSA_Instruction_t(const STARS_InstructionID_t& p_id) : STARS_Instruction_t(p_id) 
			{ }

		// Data initialization methods
		virtual bool STARS_GetCmd(void) { assert(0); }

		// Get (accessor) methods
		virtual inline uint16_t GetSize(void) const { assert(0); }
		virtual inline uint16_t GetIDAOpcode(void) { return STARS_NN_fnop; }
		virtual STARS_InstructionID_t GetNextInstructionID(void) const { assert(0); }
		virtual STARS_InstructionID_t getTargetInstructionID(void) const { assert(0); }
		virtual inline uint32_t GetInstFeatures(void) const { assert(0); }
		virtual STARSOpndTypePtr GetOpnd(std::size_t OpndNum) const { assert(0); }

		// Set (mutator) methods
		virtual void SetOpUsed(std::size_t OpndNum) { assert(0); }
		virtual void SetOpNotUsed(std::size_t OpndNum) { assert(0); }
		virtual void SetOpDefed(std::size_t OpndNum) { assert(0); }
		virtual void SetOpNotDefed(std::size_t OpndNum) { assert(0); }
		virtual void RemoveIDAOp1ForIMUL(void) { assert(0); }

		// Query methods
		virtual inline bool HasRepeatIfEqualPrefix(void) const { assert(0); }
		virtual inline bool HasRepeatIfNotEqualPrefix(void) const { assert(0); }
		virtual inline bool HasAnyRepeatPrefix(void) const { assert(0); }
		virtual bool OpcodeDefaultsTo64BitOperands(void) const { assert(0); }
		virtual bool Has64BitOperands(void) { assert(0); }
		virtual inline bool Uses64BitAddressing(void) const { assert(0); }
		virtual bool Uses32BitAddressing(void) const { assert(0); }
		virtual inline bool IsRegOpnd(std::size_t OpndNum) const { assert(0); }
		virtual inline bool IsImmedOpnd(std::size_t OpndNum) const { assert(0); }
		virtual inline bool RegOpndMatches(std::size_t OpndNum, STARS_regnum_t RegNum) const { assert(0); }
		virtual bool IsUseOpnd(std::size_t OpndNum) const { assert(0); }
		virtual bool IsDefOpnd(std::size_t OpndNum) const { assert(0); }
		virtual bool IsBranchToFarChunk(SMPInstr *CurrInst, STARS_ea_t &TargetAddr) { assert(0); }

		// Operand creation methods
		virtual STARSOpndTypePtr MakeVoidOpnd(void) const { assert(0); }
		virtual STARSOpndTypePtr MakeImmediateOpnd(STARS_uval_t value) const { assert(0); }
		virtual STARSOpndTypePtr MakeRegOpnd(STARS_regnum_t RegNum) { assert(0); }
		virtual STARSOpndTypePtr MakeFloatingPointRegOpnd(STARS_regnum_t RegNum) { assert(0); }
		virtual STARSOpndTypePtr MakeMMXRegOpnd(STARS_regnum_t RegNum) { assert(0); }
		virtual STARSOpndTypePtr MakeXMMRegOpnd(STARS_regnum_t RegNum) { assert(0); }
		virtual STARSOpndTypePtr MakeYMMRegOpnd(STARS_regnum_t RegNum) { assert(0); }
		virtual STARSOpndTypePtr MakeMemDisplacementOpnd(STARS_regnum_t BaseRegNum, STARS_regnum_t IndexRegNum, uint16_t ScaleFactor, STARS_ea_t offset) { assert(0); }
		virtual STARSOpndTypePtr MakeMemPhraseOpnd(STARS_regnum_t BaseRegNum, STARS_regnum_t IndexRegNum, uint16_t ScaleFactor) { assert(0); }

		// Analysis methods


};

#endif



