#!/bin/bash

# eg:
# 	save-bzip2.psexe.infoannot  
#	trimmed-sorted-save-bzip2.psexe.annot	

doit()
{
	dir=$1

	cd $dir
	PSEXES=`ls *exe`

	for name in $PSEXES ; do
		echo -n " Building baseline for $name in $dir ... "
		basic_filename=$name.infoannot  
		save_filename=save-$name.infoannot  
		trim_filename=trimmed-sorted-$name.annot	
		trim_save_filename=trimmed-sorted-save-$name.annot	

		# ls $save_filename $trim_save_filename 
		if [ ! -f $save_filename -o ! -f $trim_save_filename ]; then
			$SMPSA_HOME/tests/scripts/UpdateSMP64.sh $name > $name.create_baseline.log 2>&1  
		
			if [ ! -f $basic_filename -o ! -f $trim_filename ]; then
				echo
				echo "-----------------------------------------------"
				echo "Failed to build annotation files for $name"
				echo "-----------------------------------------------"
				cat $name.create_baseline.log
				echo "-----------------------------------------------"
				echo "Failed to build annotation files for $name"
				echo "-----------------------------------------------"
				exit 2
			fi
			cp $basic_filename $save_filename
			cp $trim_filename $trim_save_filename
		else
			echo -n " already exists, reusing ..."
		fi
		echo "Done."
	done

}

doit $SMPSA_HOME/tests/quick
doit $SMPSA_HOME/tests/commit

exit 0

